
/**********************BST-V51ʵ鿪************************
*  ƽ̨BST-V51 + Keil U3 + STC89C52
*  ƣDS1302ģʵ
*  ˾ǲܿƼ޹˾        
*  ڣ2013-11
*  :11.0592MHZ
*  ˵ѿԴṩԴ.
******************************************************************/
//LCD1602ԱȶѵԺãֱʹá
//£
//1.ȷװҺ1602鿴ʹֲĿ¼µҺװ
//2.ر
//óʹLCD1602ʾ
//3.ҺԱȶҺʾַѵںÿ˲
//4.ʵS4Ϊܼºѡĸ֡
//5.S8Ϊ
//6.S12ΪּС
#include<reg52.h>
#include <string.h>

#define uint unsigned int
#define uchar unsigned char
uchar a,miao,shi,fen,ri,yue,nian,week,flag,temp,key1n;
#define yh 0x80  //һеĳʼλ
#define er 0x80+0x40 //ڶгʼλ
//sbit cs1=P3^7;
//sbit ledk=P2^5;
sbit dula=P2^6;
sbit wela=P2^7;
sbit wr=P1^1;
sbit rs=P1^0;
sbit en=P2^5;
sbit SCLK=P2^1;  // 6  P1.1
sbit IO=P2^0;    // 7  P1.0
sbit RST=P2^4;   //ʱ 5  P1.2
sbit ACC0=ACC^0;
sbit ACC7=ACC^7;
sbit key=P3^7;
sbit key1=P3^0;
sbit key2=P3^1;
sbit key3=P3^2;
uchar code tab1[]={"2009-  -   THU"};
uchar code tab2[]={"  :  :  "};

#define DS1302_SECOND	0x80
#define DS1302_MINUTE	0x82
#define DS1302_HOUR		0x84 
#define DS1302_WEEK		0x8A
#define DS1302_DAY		0x86
#define DS1302_MONTH	0x88
#define DS1302_YEAR		0x8C

/*Э鶨*/
bit startBit = 0;  				//ڽտʼ־λ
bit newLineReceived = 0; 		//һ֡Э
unsigned char inputString[50];  //Э
/*------------------------------------------------
                 ڳʼ
------------------------------------------------*/
void init_com(void)
{
   	SCON = 0x50; 	// SCON: ģʽ1, 8-bit UART, ʹܽ
	TMOD |= 0x20;
	TH1=0xfd; 		//9600 ֵ
	TL1=0xfd;
	TR1= 1;
	EA = 1;	    	//ж
	ES= 1; 			//򿪴ж

}

void delay(uint xms)//ʱ
{
	uint x,y;
	for(x=xms;x>0;x--)
	 for(y=110;y>0;y--);
}
/******************Һд************************/
write_1602com(uchar com)//Һдָ
{
	rs=0;//Ϊд
	P0=com;//
	delay(1);
	en=1;//ʹܶ
	delay(1);
	en=0;//ɸ
}
write_1602dat(uchar dat)
{
	rs=1;//Ϊд
	P0=dat;//
	delay(1);
	en=1;
	delay(1);
	en=0;
}
/*********************over***********************/
/********************ds1302****************************/
void write_byte(uchar dat)
{
	ACC=dat;
	RST=1;
	for(a=8;a>0;a--)
	{
		IO=ACC0;
		SCLK=0;
		SCLK=1;
		ACC=ACC>>1;
	}
}
uchar read_byte()
{
	RST=1;
	for(a=8;a>0;a--)
	{
		ACC7=IO;
		SCLK=1;
		SCLK=0;
		ACC=ACC>>1;

	}
	return (ACC);
}
void write_1302(uchar add,uchar dat)
{

	RST=0;
	SCLK=0;
	RST=1;
	write_byte(add);
	write_byte(dat);
	SCLK=1;
	RST=0;
}
uchar read_1302(uchar add)
{
	uchar temp;
	RST=0;
	SCLK=0;
	RST=1;
	write_byte(add);
	temp=read_byte();
	SCLK=1;
	RST=0;
	return(temp);
}
void DS1302_SetTime(unsigned char Address, unsigned char Value)        // ʱ亯
{
	write_1302(0x8e,0x00);
   	write_1302(Address, ((Value/10)<<4 | (Value%10))); 
	write_1302(0x8e,0x80);
}

uchar BCD_Decimal(uchar bcd)
{
	uchar Decimal;
	Decimal=bcd>>4;
	return(Decimal=Decimal*10+(bcd&=0x0F));
}
void ds1302_init()
{
	RST=0;
	SCLK=0;
	write_1302(0x80,miao|0x00);//д
}


	

void write_sfm(uchar add,uchar dat)//дʱ
{
	uchar gw,sw;
	gw=dat%10;
	sw=dat/10;
	write_1602com(er+add);
	write_1602dat(0x30+sw);
	write_1602dat(0x30+gw);
				

}
void write_nyr(uchar add,uchar dat)
{
	uchar gw,sw;
	gw=dat%10;
	sw=dat/10;
	write_1602com(yh+add);
	write_1602dat(0x30+sw);
	write_1602dat(0x30+gw);
	

}
void write_week(uchar week)//дں
{
	write_1602com(yh+0x0d);
	switch(week)
	{
		case 1:write_1602dat('M');//delay(5);
			   write_1602dat('O');//delay(5);
			   write_1602dat('N');
			   break;
	   
		case 2:write_1602dat('T');//delay(5);
			   write_1602dat('U');//delay(5);
			   write_1602dat('E');
			   break;
		
		case 3:write_1602dat('W');//delay(5);
			   write_1602dat('E');//delay(5);
			   write_1602dat('D');
			   break;
		
		case 4:write_1602dat('T');//delay(5);
			   write_1602dat('H');//delay(5);
			   write_1602dat('U');
			   break;
		
		case 5:write_1602dat('F');//delay(5);
			   write_1602dat('R');//delay(5);
			   write_1602dat('I');
			   break;
		
		case 6:write_1602dat('S');//delay(5);
			   write_1602dat('T');//delay(5);
			   write_1602dat('A');
			   break;
		
		case 7:write_1602dat('S');//delay(5);
			   write_1602dat('U');//delay(5);
			   write_1602dat('N');
			   break;


}



}
lcd_init()//Һʼ
{       
	wr=0;
	write_1602com(0x38);//Һģʽ
	write_1602com(0x0c);//ʾʾ
	write_1602com(0x06);//ƶָһ
	write_1602com(0x01);
	write_1602com(yh+2);//ַдλ
	for(a=0;a<14;a++)
	{
		write_1602dat(tab1[a]);
		//delay(3);
	}
	write_1602com(er+4);
	for(a=0;a<8;a++)
	{
		write_1602dat(tab2[a]);
		//delay(3);
	}

}
void keyscan()
{
   	key=0;
	if(key1==0)//key1Ϊܼ
	{
	delay(5);
	if(key1==0)
	{
	while(!key1);
	key1n++;
	if(key1n==9)
		key1n=1;
	switch(key1n)
	{
	
	case 1: TR0=0;//رնʱ
			//TR1=0;
			write_1602com(er+0x0b);//дλ
		   	write_1602com(0x0f);//ùΪ˸
		   	temp=(miao)/10*16+(miao)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x80,0x80|temp);//miao
		   	write_1302(0x8e,0x80);
		   	break;
	case 2:  write_1602com(er+8);//fen
			
		     //write_1602com(0x0f);
			break;
	case 3: write_1602com(er+5);//shi
		     //write_1602com(0x0f);
			break;
	case 4: write_1602com(yh+0x0f);//week
		     //write_1602com(0x0f);
			break;
	case 5: write_1602com(yh+0x0b);//ri
		     //write_1602com(0x0f);
			break;
	case 6: write_1602com(yh+0x08);//yue
		     //write_1602com(0x0f);
			break;
	case 7: write_1602com(yh+0x05);//nian
		     //write_1602com(0x0f);
			break;
	case 8:
			write_1602com(0x0c);//ù겻˸
			TR0=1;//򿪶ʱ
			temp=(miao)/10*16+(miao)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x80,0x00|temp);//miao
		   	write_1302(0x8e,0x80);
            break;
				

													
			
	}
	
	

	}

	}
	if(key1n!=0)//key1¡ٰ¼Ч
	{
	
	if(key2==0)  //ϵ
	{
	delay(5);
	if(key2==0)
	{
	while(!key2);
	switch(key1n)
	{
	case 1:miao++;
			if(miao==60)
				miao=0;
			write_sfm(0x0a,miao);//дµ
			temp=(miao)/10*16+(miao)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x80,0x80|temp);
		   	write_1302(0x8e,0x80);
			write_1602com(er+0x0b);//ΪҺģʽдݺָԶһдԭλ
			//write_1602com(0x0b);
			break;
	case 2:fen++;
			if(fen==60)
				fen=0;
			write_sfm(0x07,fen);
			temp=(fen)/10*16+(fen)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x82,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(er+8);
			break;
	case 3:shi++;
			if(shi==24)
				shi=0;
			write_sfm(4,shi);
			temp=(shi)/10*16+(shi)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x84,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(er+5);
			break;
	case 4:week++;
			if(week==8)
				week=0;
				write_week(week);
			
			write_1602com(yh+0x0f);
			break;
	case 5:ri++;
			if(ri==31)
				ri=0;
			write_nyr(10,ri);
			temp=(ri)/10*16+(ri)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x86,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(yh+11);
			break;
	case 6:yue++;
			if(yue==13)
				yue=0;
			write_nyr(7,yue);
			temp=(yue)/10*16+(yue)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x88,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(yh+8);
			break;
	case 7:nian++;
		 if(nian==100)
			nian=0;
			write_nyr(4,nian);
			write_1602com(yh+5);
			break;
			

	}

	}

	}
	if(key3==0)
	{
	delay(5);
	if(key3==0)
	{
	while(!key3);
	switch(key1n)
	{
		case 1:miao--;
				if(miao==-1)
					miao=59;
			write_sfm(0x0a,miao);//дµ
			write_1602com(er+0x0b);//ΪҺģʽдݺָԶһдԭλ
			//write_1602com(0x0b);
			break;
		case 2:fen--;
				if(fen==-1)
					fen=59;
			write_sfm(7,fen);
			temp=(fen)/10*16+(fen)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x82,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(er+8);
			break;

		case 3:shi--;
			   if(shi==-1)
					shi=23;
			write_sfm(4,shi);
			temp=(shi)/10*16+(shi)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x84,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(er+5);
			break;
		case 4:week--;
				if(week==-1)
					week=7;
			write_week(week);
			write_1602com(yh+0x0f);
			break;
		case 5:ri--;
				if(ri==-1)
					ri=30;
			write_nyr(10,ri);
			temp=(ri)/10*16+(ri)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x86,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(yh+11);
			break;
		case 6:yue--;
				if(yue==-1)
					yue=12;
			write_nyr(7,yue);
			temp=(yue)/10*16+(yue)%10;
		   	write_1302(0x8e,0x00);
		   	write_1302(0x88,temp);
		   	write_1302(0x8e,0x80);
			write_1602com(yh+8);
			break;	
		case 7:nian--;
		 if(nian==-1)
			nian=99;
			write_nyr(4,nian);
			write_1602com(yh+5);
			break;
			
				
	}

	}

	}

	}



}
void init()
{
	TMOD |= 0x01;
	TH0=0x4C;   //ʱ50ms 
	TL0=0;
	EA=1;
	ET0=1;
	TR0=1;



}

void cmg(void)//溯
{
	dula=1;
	P0=0x00;
	dula=0;
	wela=1;
	P0=0x00;
	wela=0;
}
void main()
{
	uchar read_year, read_month, read_day, read_hour, read_minute, read_seconds;
   	cmg();//
	lcd_init();
	ds1302_init();
	init();
	init_com();
	while(1)
	{
		keyscan();
		//ʼЭ $51,TIME1,20170520110156#
		while (newLineReceived)  //Эݽһ
		{
			//жǷ51Э
			if(inputString[1] != '5' || inputString[2] != '1')
			{
			 	newLineReceived = 0;  
		   		memset(inputString, 0x00, sizeof(inputString)); 
				break; 
			}
			//жǷʱõЭ
		 	if(inputString[4] != 'T' || inputString[5] != 'I' || inputString[6] != 'M' || inputString[7] != 'E')
			{
				newLineReceived = 0;  
	   			memset(inputString, 0x00, sizeof(inputString)); 
				break;	
			}
			//жǷ1602ʾ
			if(inputString[8] != '2')
			{
				newLineReceived = 0;  
	   			memset(inputString, 0x00, sizeof(inputString)); 
				break;
			}

			//ʼȡ  λ12 ʼ  $51,TIME1,20170520110156#
			read_year = (inputString[12] - 0x30)*10 + (inputString[13] - 0x30);
			read_month = (inputString[14] - 0x30)*10 + (inputString[15] - 0x30);
			read_day = (inputString[16] - 0x30)*10 + (inputString[17] - 0x30);
			
			read_hour = (inputString[18] - 0x30)*10 + (inputString[19] - 0x30);
			read_minute = (inputString[20] - 0x30)*10 + (inputString[21] - 0x30);
			read_seconds = (inputString[22] - 0x30)*10 + (inputString[23] - 0x30);
			
			//TR0=0;
			DS1302_SetTime(DS1302_YEAR, read_year);	//õʱ170530
			DS1302_SetTime(DS1302_MONTH, read_month);
			DS1302_SetTime(DS1302_DAY, read_day);  
			DS1302_SetTime(DS1302_HOUR, read_hour);	//õʱ170530
			DS1302_SetTime(DS1302_MINUTE, read_minute);
			DS1302_SetTime(DS1302_SECOND, read_seconds);   
			//TR0=1;
		 	newLineReceived = 0;  
	   		memset(inputString, 0x00, sizeof(inputString)); 
			break;
		}
    }
}
void timer0() interrupt 1
{
	static uchar m = 0;
	TH0=0x4C;
	TL0=0;
	m++;
	if(m==10) //500ms	 ˢһ
	{
		m = 0;
		miao = BCD_Decimal(read_1302(0x81));
		fen = BCD_Decimal(read_1302(0x83));
		shi  = BCD_Decimal(read_1302(0x85));
		ri  = BCD_Decimal(read_1302(0x87));
		yue = BCD_Decimal(read_1302(0x89));
		nian=BCD_Decimal(read_1302(0x8d));
		week=BCD_Decimal(read_1302(0x8b));
	
		write_sfm(10,miao);
		write_sfm(7,fen);
		write_sfm(4,shi);
		
		write_nyr(4,nian);
		write_nyr(10,ri);
	    write_nyr(7,yue);
		write_week(week);	
	}

	
}
/******************************************************************/
/* жϳ*/
/******************************************************************/
void UART_SER () interrupt 4
{
	unsigned char n; 	//ʱ
	static int num = 0;

	if(RI) 		//жǽжϲ
	{
		RI = 0; 	//־λ
		n = SBUF; //뻺ֵ

		//control=n;
	    if(n == '$')
	    {
	      startBit = 1;
		  num = 0;
	    }
	    if(startBit == 1)
	    {
	       inputString[num] = n; 
		   num++;    
	    }  
	    if (startBit == 1 && n == '#') 
	    {
	       newLineReceived = 1; 
	       startBit = 0;
		   num = 0;
	    }
		
		if(num >= 50)
		{
			num = 0;
			startBit = 0;
			newLineReceived	= 0;
		}
	}

}
